# sfepy.discrete.iga.mappings module

Reference mappings for isogeometric analysis.

class sfepy.discrete.iga.mappings.IGMapping(domain, cells, nurbs=None)

  Reference mapping for isogeometric analysis based on Bezier extraction.

  Parameters:
    domain IGDomain instance

      The mapping domain.

    cells array

      The mapping region cells. (All domain cells required.)

    nurbs NurbsPatch instance, optional

      If given, the nurbs is used instead of domain.nurbs. The nurbs has to be obtained by degree elevation of domain.nurbs.

  get_geometry()

    Return reference element geometry as a GeometryElement instance.

  get_mapping(qp_coors, weights)

    Get the mapping for given quadrature points and weights.

    Returns:
      cmap CMapping instance

        The reference mapping.

    Notes

    Does not set total volume of the C mapping structure!

  get_physical_qps(qp_coors)

    Get physical quadrature points corresponding to given reference Bezier element quadrature points.

    Returns:
      qps array

        The physical quadrature points ordered element by element, i.e. with shape (n_el, n_qp, dim).